org.jfree.data.time

## Class Minute

- java.lang.Object
- - org.jfree.data.time.RegularTimePeriod
  - - org.jfree.data.time.Minute

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Comparable, TimePeriod, MonthConstants

      public class Minute
      extends RegularTimePeriod
      implements java.io.Serializable

  Represents a minute. This class is immutable, which is a requirement for all `RegularTimePeriod` subclasses.
  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `FIRST_MINUTE_IN_HOUR` Useful constant for the first minute in a day.
    `static int` | `LAST_MINUTE_IN_HOUR` Useful constant for the last minute in a day.

    - ### Fields inherited from class org.jfree.data.time.RegularTimePeriod

      `DEFAULT_TIME_ZONE, WORKING_CALENDAR`

    - ### Fields inherited from interface org.jfree.date.MonthConstants

      `APRIL, AUGUST, DECEMBER, FEBRUARY, JANUARY, JULY, JUNE, MARCH, MAY, NOVEMBER, OCTOBER, SEPTEMBER`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Minute()` Constructs a new Minute, based on the system date/time.
    `Minute(java.util.Date time)` Constructs a new instance, based on the supplied date/time and the default time zone.
    `Minute(java.util.Date time, java.util.TimeZone zone)` Deprecated. As of 1.0.13, use the constructor that specifies the locale also.
    `Minute(java.util.Date time, java.util.TimeZone zone, java.util.Locale locale)` Constructs a new Minute, based on the supplied date/time and timezone.
    `Minute(int minute, Hour hour)` Constructs a new Minute.
    `Minute(int minute, int hour, int day, int month, int year)` Creates a new minute.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `compareTo(java.lang.Object o1)` Returns an integer indicating the order of this Minute object relative to the specified object: negative == before, zero == same, positive == after.
    `boolean` | `equals(java.lang.Object obj)` Tests the equality of this object against an arbitrary Object.
    `Day` | `getDay()` Returns the day.
    `long` | `getFirstMillisecond()` Returns the first millisecond of the minute.
    `long` | `getFirstMillisecond(java.util.Calendar calendar)` Returns the first millisecond of the minute.
    `Hour` | `getHour()` Returns the hour.
    `int` | `getHourValue()` Returns the hour.
    `long` | `getLastMillisecond()` Returns the last millisecond of the minute.
    `long` | `getLastMillisecond(java.util.Calendar calendar)` Returns the last millisecond of the minute.
    `int` | `getMinute()` Returns the minute.
    `long` | `getSerialIndex()` Returns a serial index number for the minute.
    `int` | `hashCode()` Returns a hash code for this object instance.
    `RegularTimePeriod` | `next()` Returns the minute following this one.
    `static Minute` | `parseMinute(java.lang.String s)` Creates a Minute instance by parsing a string.
    `void` | `peg(java.util.Calendar calendar)` Recalculates the start date/time and end date/time for this time period relative to the supplied calendar (which incorporates a time zone).
    `RegularTimePeriod` | `previous()` Returns the minute preceding this one.

    - ### Methods inherited from class org.jfree.data.time.RegularTimePeriod

      `createInstance, downsize, getEnd, getFirstMillisecond, getLastMillisecond, getMiddleMillisecond, getMiddleMillisecond, getMiddleMillisecond, getMillisecond, getStart, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### FIRST_MINUTE_IN_HOUR

          public static final int FIRST_MINUTE_IN_HOUR

      Useful constant for the first minute in a day.
      See Also:
        Constant Field Values

    - #### LAST_MINUTE_IN_HOUR

          public static final int LAST_MINUTE_IN_HOUR

      Useful constant for the last minute in a day.
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### Minute

          public Minute()

      Constructs a new Minute, based on the system date/time.

    - #### Minute

          public Minute(int minute,
                        Hour hour)

      Constructs a new Minute.
      Parameters:
        `minute` - the minute (0 to 59).
        `hour` - the hour (`null` not permitted).

    - #### Minute

          public Minute(java.util.Date time)

      Constructs a new instance, based on the supplied date/time and the default time zone.
      Parameters:
        `time` - the time (`null` not permitted).
      See Also:
        `Minute(Date, TimeZone)`

    - #### Minute

          public Minute(java.util.Date time,
                        java.util.TimeZone zone)

      Deprecated. As of 1.0.13, use the constructor that specifies the locale also.
      Constructs a new Minute, based on the supplied date/time and timezone.
      Parameters:
        `time` - the time (`null` not permitted).
        `zone` - the time zone (`null` not permitted).

    - #### Minute

          public Minute(java.util.Date time,
                        java.util.TimeZone zone,
                        java.util.Locale locale)

      Constructs a new Minute, based on the supplied date/time and timezone.
      Parameters:
        `time` - the time (`null` not permitted).
        `zone` - the time zone (`null` not permitted).
        `locale` - the locale (`null` not permitted).
      Since:
        1.0.13

    - #### Minute

          public Minute(int minute,
                        int hour,
                        int day,
                        int month,
                        int year)

      Creates a new minute.
      Parameters:
        `minute` - the minute (0-59).
        `hour` - the hour (0-23).
        `day` - the day (1-31).
        `month` - the month (1-12).
        `year` - the year (1900-9999).

  - ### Method Detail

    - #### getDay

          public Day getDay()

      Returns the day.
      Returns:
        The day.
      Since:
        1.0.3

    - #### getHour

          public Hour getHour()

      Returns the hour.
      Returns:
        The hour (never `null`).

    - #### getHourValue

          public int getHourValue()

      Returns the hour.
      Returns:
        The hour.
      Since:
        1.0.3

    - #### getMinute

          public int getMinute()

      Returns the minute.
      Returns:
        The minute.

    - #### getFirstMillisecond

          public long getFirstMillisecond()

      Returns the first millisecond of the minute. This will be determined relative to the time zone specified in the constructor, or in the calendar instance passed in the most recent call to the `peg(Calendar)` method.
      Specified by:
        `getFirstMillisecond` in class `RegularTimePeriod`
      Returns:
        The first millisecond of the minute.
      See Also:
        `getLastMillisecond()`

    - #### getLastMillisecond

          public long getLastMillisecond()

      Returns the last millisecond of the minute. This will be determined relative to the time zone specified in the constructor, or in the calendar instance passed in the most recent call to the `peg(Calendar)` method.
      Specified by:
        `getLastMillisecond` in class `RegularTimePeriod`
      Returns:
        The last millisecond of the minute.
      See Also:
        `getFirstMillisecond()`

    - #### peg

          public void peg(java.util.Calendar calendar)

      Recalculates the start date/time and end date/time for this time period relative to the supplied calendar (which incorporates a time zone).
      Specified by:
        `peg` in class `RegularTimePeriod`
      Parameters:
        `calendar` - the calendar (`null` not permitted).
      Since:
        1.0.3

    - #### previous

          public RegularTimePeriod previous()

      Returns the minute preceding this one.
      Specified by:
        `previous` in class `RegularTimePeriod`
      Returns:
        The minute preceding this one.

    - #### next

          public RegularTimePeriod next()

      Returns the minute following this one.
      Specified by:
        `next` in class `RegularTimePeriod`
      Returns:
        The minute following this one.

    - #### getSerialIndex

          public long getSerialIndex()

      Returns a serial index number for the minute.
      Specified by:
        `getSerialIndex` in class `RegularTimePeriod`
      Returns:
        The serial index number.

    - #### getFirstMillisecond

          public long getFirstMillisecond(java.util.Calendar calendar)

      Returns the first millisecond of the minute.
      Specified by:
        `getFirstMillisecond` in class `RegularTimePeriod`
      Parameters:
        `calendar` - the calendar which defines the timezone (`null` not permitted).
      Returns:
        The first millisecond.
      Throws:
        `java.lang.NullPointerException` - if `calendar` is `null`.
      See Also:
        `RegularTimePeriod.getLastMillisecond(Calendar)`

    - #### getLastMillisecond

          public long getLastMillisecond(java.util.Calendar calendar)

      Returns the last millisecond of the minute.
      Specified by:
        `getLastMillisecond` in class `RegularTimePeriod`
      Parameters:
        `calendar` - the calendar / timezone (`null` not permitted).
      Returns:
        The last millisecond.
      Throws:
        `java.lang.NullPointerException` - if `calendar` is `null`.
      See Also:
        `RegularTimePeriod.getFirstMillisecond(Calendar)`

    - #### equals

          public boolean equals(java.lang.Object obj)

      Tests the equality of this object against an arbitrary Object.

      This method will return true ONLY if the object is a Minute object representing the same minute as this instance.

      Overrides:
        `equals` in class `java.lang.Object`
      Parameters:
        `obj` - the object to compare (`null` permitted).
      Returns:
        `true` if the minute and hour value of this and the object are the same.

    - #### hashCode

          public int hashCode()

      Returns a hash code for this object instance. The approach described by Joshua Bloch in "Effective Java" has been used here:

      `http://developer.java.sun.com/developer/Books/effectivejava /Chapter3.pdf`

      Overrides:
        `hashCode` in class `java.lang.Object`
      Returns:
        A hash code.

    - #### compareTo

          public int compareTo(java.lang.Object o1)

      Returns an integer indicating the order of this Minute object relative to the specified object: negative == before, zero == same, positive == after.
      Specified by:
        `compareTo` in interface `java.lang.Comparable`
      Parameters:
        `o1` - object to compare.
      Returns:
        negative == before, zero == same, positive == after.

    - #### parseMinute

          public static Minute parseMinute(java.lang.String s)

      Creates a Minute instance by parsing a string. The string is assumed to be in the format "YYYY-MM-DD HH:MM", perhaps with leading or trailing whitespace.
      Parameters:
        `s` - the minute string to parse.
      Returns:
        `null`, if the string is not parseable, the minute otherwise.